Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO

Namespace Human
    ''' <summary>
    ''' This is the person class that inherits from collection base. 
    ''' we will be able to add a PersonName class to the collection in which we will serialize
    ''' </summary>
    ''' <remarks></remarks>
    <Serializable(), XmlRoot("People")> _
    Public Class People : Inherits CollectionBase
        ''' <summary>
        ''' Holds the collection of names. 
        ''' </summary>
        ''' <param name="Index"></param>
        ''' <value></value>
        ''' <returns></returns>
        ''' <remarks></remarks>
        ''' 
        <XmlArrayItem("Person", GetType(String))> _
        Default Public Property PersonCollection(ByVal Index As Integer) As Person
            Get
                Return List(Index)
            End Get
            Set(ByVal value As Person)
                List(Index) = value
            End Set
        End Property
        ''' <summary>
        ''' Person class that holds First Name and Last Name values
        ''' You could add any property you wanted to that describes a person.
        ''' I just used First and last name 
        ''' </summary>
        ''' <remarks></remarks>
        <Serializable()> _
        Public Class Person
#Region "Private member variables"
            Private _FirstName As String
            Private _LastName As String

#End Region
            <XmlElement("FirstName")> _
            Public Property FirstName() As String
                Get
                    Return _FirstName
                End Get
                Set(ByVal value As String)
                    _FirstName = value
                End Set
            End Property
            <XmlElement("LastName")> _
            Public Property LastName() As String
                Get
                    Return _LastName
                End Get
                Set(ByVal value As String)
                    _LastName = value
                End Set
            End Property
            Sub New()
                'serializable classes must have an empty constructor

            End Sub
        End Class

        Function Add(ByVal P As Person) As Integer
            List.Add(P)
        End Function
        Sub New()
            'serializable classes must have an empty constructor

        End Sub
    End Class
End Namespace

